#include <FastLED.h>
#define NUM_LEDS 144
#define DATA_PIN 2

//On définie un tableau de leds de la taille du nombre leds que l'on possède 
CRGB leds[NUM_LEDS];
CRGB randomled;
int I = NUM_LEDS;
int J = 0;
CRGB led;
int r = 255;
int g = 0;
int b = 0;
int color;
int state = 0;
char value[1];

void setup() {
  //On commence un serial avec 9600 de baud
  Serial.begin(9600);
  //On initialise toutes nos leds dans grâce a FastLed
  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
  //On commence avec la couleur Rouge
  led = CRGB::Red;
  color = 1;
  value[0] = 'm';
  state = 0;
  for (int i = 0; i < NUM_LEDS; i++) leds[i] = led;
  FastLED.show();
}


int get_color() {
  //On regarde les valeurs de vert rouge et bleu afin d'y affecter la prochaine couleur à obtenir
  if (g == 255 && r == 255 && b == 0) return (2);
  if (g == 255 && r == 0 && b == 0) return (3);
  if (g == 255 && b == 255 && r == 0) return (4);
  if (g == 0 && b == 255 && r == 0) return (5);
  if (b == 255 && r == 255 && g == 0) return (6);
  if (b == 0 && r == 255 && g == 0) return (1);
}

void randomColor() {
  //On recupere la couleur actuel
  color = get_color();
  //En fonction des couleurs on modifie soit le r soit le g soit le b
  if (color == 1) {
    if (g < 255) g++;
  }else if (color == 2) {
    if (r > 0) r--;
  }else if (color == 3) {
    if (b < 255) b++;
  }else if (color == 4) {
    if (g > 0) g--;  
  }else if (color == 5) {
    if (r < 255) r++;  
  }else if (color == 6) {
    if (b > 0) b--;  
  }
  //On rajoute a la led le r, g et b ainsi obtenue
  led.r = r;
  led.g = g;
  led.b = b;
  
  for (int i = 0; i < NUM_LEDS; i++) {
    if (i < I && i > J)
      leds[i] = led;
  }
  randomled.r = random(0, 255);
  randomled.g = random(0, 255);
  randomled.b = random(0, 255);
  for (int i = 1; i <= 4; i++) {
    leds[J + i] = randomled;
    leds[I - i] = randomled;
  }
}

void menu() {
  //On applique la couleur qui se trouve entre les deux traits rouges
  randomColor();
  //On fait bouger les traits en fonction de leurs états
  if ((I > NUM_LEDS / 2) && !state) {
    leds[I] = CRGB::Red;
    I--;
    if (I == NUM_LEDS / 2) state = 1;
  }else if (I < NUM_LEDS){
    I++;
  }else {
    state = 0;
    I = NUM_LEDS;
    J = 0;
  }
  if (J <= NUM_LEDS / 2 && !state) {
    leds[J] = CRGB::Red;
    J++;
    if (J == NUM_LEDS / 2) state = 1;
  }else if (J > 0 && state){
    J--;
  }else {
    state = 0;
    I = NUM_LEDS;
    J = 0;
  } 
}

void game() {
  //On Initialise les variables servants au menu pour eviter tout ceci lors du retour au menu
  I = NUM_LEDS;
  J = 0;
  //En fonction des valeurs on elair 6 leds situer au niveau de la touche presser
  if (value[0] == '1') {
    for (int i = 0; i < 6; i++) leds[i] = CRGB::White;
  }else if (value[0] == '2') {
    for (int i = 33; i < 39; i++) leds[i] = CRGB::White;
  }else if (value[0] == '3') {
    for (int i = NUM_LEDS / 2 - 3; i < NUM_LEDS / 2 + 3; i++) leds[i] = CRGB::White;
  }else if (value[0] == '4') {
    for (int i = 105; i < 111; i++) leds[i] = CRGB::White;
  }else if (value[0] == '5') {
    for (int i = NUM_LEDS - 6; i < NUM_LEDS; i++) leds[i] = CRGB::White;
  }
  
}

void loop() {
  //On regarde si il y a un message de disponible de la taille de 1 byte, si c'est le cas on le lit et on l'affecte au tableau de char value sinon on affecte 'N' a la premiere case du tableau value
  if (Serial.available() >= 1) {
    Serial.readBytes(value, 1);
  }else {
    value[0] = 'N';
  }
  //Si il y a un 'N' a la premiere case du tableau on eteint la led
  if (value[0] == 'N') {
    for (int i = 0; i < NUM_LEDS; i++) {
        leds[i] = CRGB::Black;
      }
      I = NUM_LEDS;
      J = 0;
      FastLED.show();
    }
  //Si 'm' est envoyé par le jeu cela signifie que l'on est dans le menu
  if (value[0] == 'm') {
    menu();
  //Si il y a '1', '2', '3', '4' ou '5' envoyé par le jeu cela signifie que l'on est en jeu et que la touche référente au numero est appuyer donc on eclair seulement les leds qui se situent aux niveaux des touches 
  }else if (value[0] == '1' || value[0] == '2' || value[0] == '3' || value[0] == '4' || value[0] == '5'){
    game();
  //On affecte 'N' a value pour éteindre la led
    value[0] = 'N';
  }
   //Et on applique les nouvelles valeurs;
   FastLED.show();
   delay(15);
}
